// ==UserScript==
// @name           ubuntu.ru personal trash
// @description   Добавление персональной корзины для forum.ubuntu.ru.
// @author        easy2002(e2002@bk.ru)
// @namespace      http://www.w3.org/1999/xhtml
// @include        http://forum.ubuntu.ru/index.php?action=profile
// @include        http://forum.ubuntu.ru/index.php?action=unread*
// @include        http://forum.ubuntu.ru/index.php?board=*
// @include        http://forum.ubuntu.ru/index.php?topic=*
// @version       1.0.0
// ==/UserScript==

// Усовершенствованный скрипт tartan-a
// http://forum.ubuntu.ru/index.php?topic=111866.0
// установка (HowTo) - http://userscripts.ru/

/******************************** настройки ***********************************/

var testline = true; //Отображать линию в 3px с подсказкой вместо скрытых сообщений. Можно заменить на false

var preset = new Array(); //Для черного списка по умолчанию
//Сюда добавляем любимых героев, после чего в профиле заработает кнопка Банлист->По умолчанию
//-= Это не обязательно, скрипт работает и без этого списка. Предназначено для переноса записей из скрипта tartan-a =-
//Пример:
//preset.push([11171,'easy2002']);//это я

/******************************** конец настроек ******************************/

var uw = (this.unsafeWindow) ? this.unsafeWindow : window; //FF:Opera
if(window.navigator.vendor && window.navigator.vendor.match(/Google/)) { //Chrome
    var div = document.createElement("div");
    div.setAttribute("onclick", "return window;");
    uw = div.onclick();
};

var lc=window.location.href;
var isBoard = lc.indexOf('unread')>0 || lc.indexOf('board')>0
var isTopic = lc.indexOf('topic')>0
var isProfile = lc.indexOf('profile')>0

function getObject(key){
    var result = JSON.parse(localStorage.getItem(key))
    return result?result:[];
}

Array.prototype.searchbyid =  function(userid) {
    for (var i = 0; i < this.length; i++){
        if (this[i][0] == userid){
            return i;
        }    
    }
    return -1;
} 

var blacklist=getObject('blacklist');
var mytrash=getObject('mytrash');

if(isProfile){
    var banstring='';
    var trashstring='';
    uw.loadPreset = function(){
        if(preset.length==0){
            alert("Список по умолчанию пуст!\nОтредактируйте ubunturu_personaltrash.user.js");
            return;
        }
        if (confirm("Уверены, что хотите восстановить банлист по умолчанию?")) {
            localStorage.setItem('blacklist', JSON.stringify(preset));
            window.location.reload();
        }
    }

    uw.removeStorage = function(){
        if (confirm("Уверены, что хотите очистить банлист?")) {
            localStorage.removeItem('blacklist');
            window.location.reload();
        }
    }

    uw.removeTrash = function(){
        if (confirm("Уверены, что хотите восстановить все элементы из корзины?")) {
            localStorage.removeItem('mytrash');
            window.location.reload();
        }
    }

    uw.unban = function(uid,username){
        if (confirm("Уверены, что хотите разбанить "+username+"?")) {
            blacklist.splice(blacklist.searchbyid(uid),1);
            localStorage.setItem('blacklist', JSON.stringify(blacklist));
            window.location.reload();
        }
    }

    uw.untrash = function(topicid,topictitle){
        if (confirm("Уверены, что хотите восстановить "+topictitle+"?")) {
            mytrash.splice(mytrash.searchbyid(topicid),1);
            localStorage.setItem('mytrash', JSON.stringify(mytrash));
            window.location.reload();
        }
    }

    uw.addTD = function(parent, text){
        var newtr=document.createElement("tr");
        var newtd=document.createElement("td");
        newtd.setAttribute('colspan','2');
        newtd.className="windowbg2";
        newtd.innerHTML=text;
        newtr.appendChild(newtd);
        parent.appendChild(newtr);
    }
    for (var i = 0; i < blacklist.length; i++){
        banstring += '<a href="/index.php?action=profile;u='+blacklist[i][0]+'" target="_blank" title="Профиль">'+blacklist[i][1]+'</a> [<a style="color: red;" title="Разбанить" href="javascript:unban('+blacklist[i][0]+',\''+blacklist[i][1]+'\');">x</a>], ';
    }

    for (var i = 0; i < mytrash.length; i++){
        trashstring += '<span style="font-size: 10px;">'+(i+1)+'. <a href="/index.php?topic='+mytrash[i][0]+'.0" target="_blank" title="Перейти">'+mytrash[i][1]+'</a></span> [<a style="color: red;" href="javascript:untrash('+mytrash[i][0]+',\''+mytrash[i][1]+'\');" title="Восстановить">x</a>]<br />';
    }

    var node = document.querySelector('table.bordercolor[align="center"]');
    uw.addTD(node,'<strong>Банлист: </strong><a href="javascript:removeStorage();" title="Очистить"><img src="/Themes/classic/images/icons/delete.gif"/></a> <a href="javascript:loadPreset();" title="По умолчанию"><img src="/Themes/classic/images/topic/hot_post_sticky.gif"/></a><br />'+banstring);
    uw.addTD(node,'<strong>Персональная корзина: </strong><a href="javascript:removeTrash();" title="Очистить"><img src="/Themes/classic/images/icons/delete.gif"/></a><br />'+trashstring);
}//isProfile
/******************************************************************************/

if(isBoard){
    for (var i = 0; i < blacklist.length; i++){
	    var userid = blacklist[i][0];
	    var url = '?action=profile;u='+userid;
	    var expression = '//tr[td[@width="14%"]/a[contains(@href,"' + url + '")]]';
	
	    var nodes = document.evaluate(expression, document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);

	    for (var j = 0; j < nodes.snapshotLength; j++) {
		    var node = nodes.snapshotItem(j);
		    if(testline){
		        node.innerHTML='<td colspan="7" style="font-size: 0; height: 3px; padding: 0; background: #F0B0B0;" title="Здесь был '+blacklist[i][1]+'"></td>';
		    }else{
		        node.style.display = 'none';
		    }
	    }
    }

    for (var i = 0; i < mytrash.length; i++){
	    var topicid = mytrash[i][0];
	    var url = '?topic='+topicid+'.0';
	    var expression = '//tr[td/a[contains(@href,"' + url + '")]] | //tr[td/*/a[contains(@href,"' + url + '")]]';
	
	    var nodes = document.evaluate(expression, document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);

	    for (var j = 0; j < nodes.snapshotLength; j++) {
		    var node = nodes.snapshotItem(j);
		    if(testline){
		        node.innerHTML='<td colspan="7" style="font-size: 0; height: 3px; padding: 0; background: #F0B0B0;" title="'+mytrash[i][1]+'"></td>';
		    }else{
		        node.style.display = 'none';
		    }
	    }
    }
}//isBoard
/******************************************************************************/

if(isTopic){
    uw.ban = function(userid,username){
        if (confirm("Уверены, что хотите забанить "+username+"?")) {
            blacklist.push([userid,username]);
            localStorage.setItem('blacklist', JSON.stringify(blacklist));
            uw.hideposts();
        }
    }

    uw.hideposts = function(){ //Скрывает посты в http://forum.ubuntu.ru/index.php?topic=*
        for (var i = 0; i < blacklist.length; i++){
	        var expression = '//td[table/tbody/tr/td/table/tbody/tr/td/b/a[contains(@href,"action=profile;u=' + blacklist[i][0] + '")]]';
	        var nodes = document.evaluate(expression, document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	        for (var j = 0; j < nodes.snapshotLength; j++) {
		        var node = nodes.snapshotItem(j);
		        if(testline){
		            node.innerHTML='<div style="font-size: 0; height: 3px; background: #F0B0B0;" title="Здесь был '+blacklist[i][1]+'"></div>';
		        }else{
		            node.style.display = 'none';
		        }
	        }   
        }
    }

    uw.removeTopic = function() {
        var reg = /topic=(\d+)/;    
        if (confirm("Уверены, что хотите удалить "+document.title+" в корзину?")) {
            mytrash.push([reg.exec(window.location)[1],document.title]);
            localStorage.setItem('mytrash', JSON.stringify(mytrash));
            window.history.back();
        }
    }

    var expression = '//td[@valign="top"][@width="16%"]';
    var nodes = document.evaluate(expression, document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);

    for (var j = 0; j < nodes.snapshotLength; j++) {
		    var node = nodes.snapshotItem(j);
		    var reg = /action=profile;u=(\d+).+?>(.+?)<\/a>/;
		    if (reg.test(node.innerHTML)) {
		        var arr=reg.exec(node.innerHTML);
		        var newdiv=document.createElement("div");
		        newdiv.innerHTML='<a href="javascript:ban('+arr[1]+',\''+arr[2]+'\');" title="Забанить '+arr[2]+'"><img src="/Themes/classic/images/icons/delete.gif" /></a>';
		        node.appendChild(newdiv);
		    }
    }

    var blacklist=getObject('blacklist');
    var mytrash=getObject('mytrash');

    uw.hideposts();

    if(mytrash.searchbyid(window.location.href.match(/topic=(\d+)/)[1])<0){
        var expression = '//span[@class="nav"] | //div/div[@class="nav"]';
        var nodes = document.evaluate(expression, document, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
        for (var j = 0; j < nodes.snapshotLength; j++) {
            var node = nodes.snapshotItem(j);
            node.innerHTML += ' | <a href="javascript:removeTopic();" title="В корзину"><img align="middle" src="/Themes/classic/images/icons/quick_remove.gif" /></a>'
        }
    }
}//isTopic
